# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2007  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# version unicode

from LIB import *

class Historique:
    def __init__(self, parent):
        self.parent = parent
        self.initialiser_historique()

    def enregistrer(self, commande = "", archiver = True):
        self.liste_annulations = []
        # avec la molette de la souris, on effectue une succession rapide de zooms
        # pour eviter que ca ne remplisse l'historique, on archive alors l'etat actuel a la place du precedent.
        if commande.startswith(u"zoomer(") and self.liste_actions[-1].startswith(u"zoomer("):
            self.liste_actions[-1] = u"zoomer(%s)" % str(eval(self.liste_actions[-1][7:-1])*eval(commande[7:-1]))
        else:
            self.liste_actions.append(commande)
        if self.parent.actuelle and archiver:
            self.parent.actuelle.historique.archiver(commande)
            if not self.parent.actuelle.sauvegarde[u"modifie"]:
                self.parent.actuelle.sauvegarde[u"modifie"] = True # une modification a t faite depuis la dernire sauvegarde
                self.parent.rafraichir_titre()  # rajoute une "*" dans le titre de la fentre
            #print "Archivage : ", commande
            #print self.parent.actuelle.historique.etats
        if param.historique_log_continu:    self.historique.stocker()


    def initialiser_historique(self):
        self.liste_actions = []
        self.liste_annulations = []


    def contenu(self):
        return "\n".join(self.liste_actions)

    def executer(self, commande):
        self.parent.commande.executer(commande)


    def stocker(self):
        texte = self.contenu()
        if isinstance(texte, unicode):  # version unicode de WxPython
            texte = texte.encode(param.encodage) # Par dfaut, Python tente de le convertir en str  l'aide du codec ASCII
        f=open(path2(param.emplacements["log"] + "/" + self.parent.nom + u"_historique.log"), "w")
        f.write(texte)
        f.close()


    def annuler(self, event = None):
        if self.parent.actuelle:
            self.parent.actuelle.historique.annuler()
            self.parent.canvas.regenerer_liste = True


    def retablir(self, event = None):
        if self.parent.actuelle:
            self.parent.actuelle.historique.refaire()
            self.parent.canvas.regenerer_liste = True



