# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2007  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#version unicode

    #try: 
    #    import psyco; 
    #    psyco.profile() 
    #except: 
    #    pass
  


import sys
import param
options = False
for arg in sys.argv: # on prend en compte les options ventuelles (ce sont tous les arguments qui suivent l'argument "-o")
    if options:
        try:
            nom, valeur = arg.split("=", 1)
            setattr(param, nom, eval(valeur)) # pas sensass question scurit... :-(
        except:
            raise
            print "Option incorrecte."
    elif arg == "-o":
        options = "True"
del options, arg

import API
from LIB import *


def initialiser():
    arguments = []
    for arg in sys.argv: # les options ne sont plus  prendre en compte
        if arg == "-o":
            break
        arguments.append(arg)
        
    if len(arguments) > 1 and arguments[-2] == "-o":
        options = arguments.pop()
        arguments.pop()
        
        
    param.EMPLACEMENT = os.getcwd()
    app = wx.PySimpleApp()
    path = path2(param.emplacements["preferences"] + "/parametres.xml")
    try:
        if os.path.exists(path):
            # on charge les prfrences de l'utilisateur depuis parametres.xml
            a_verifier = {}
            a_verifier.update([(dico, getattr(param, dico)) for dico in param.a_mettre_a_jour])
            API.actualiser_module(param, path)
            # certains paramtres peuvent avoir besoin d'une mise  jour (en cas de changement de version de wxgomtrie par exemple)
            # cela concerne en particulier les dictionnaires, qui peuvent gagner de nouvelles cls.
            for dictionnaire in param.a_mettre_a_jour:
                for key in a_verifier[dictionnaire].keys():
                    getattr(param, dictionnaire).setdefault(key, a_verifier[dictionnaire][key])
    except:
        print_error()
    app.SetAppName(u"WxGomtrie")
    #~ print "Test 2.5"
    import GUI
    #~ print "Test 3"
    if param.debug:
        app.RedirectStdio(None)     # redirection vers une fenetre de messages
       
    elif param.enregistrer_messages:
        filename = path2(param.emplacements["log"] + u"/messages.log")
        try:
            open(filename, "w").close() # on purge le fichier de log
            app.RedirectStdio(filename)
        except IOError:
            print_error()
            param.enregistrer_messages = param.historique_log = False

    #~ print "Test 4"
    app.SetOutputWindowAttributes(title = u"WxGomtrie - messages.")
    if param.erreurs_initialisation:
        print param.erreurs_initialisation

    try:
        frame = GUI.WxGeometrie(app)
        try:
            if len(arguments) > 1:
                for arg in arguments[1:]:
                    frame.onglets.ouvrir(arg) # ouvre le fichier pass en paramtre
                #fichier = arguments[1]
                #fgeo, message = ouvrir_fichierGEO(fichier)
                #module = frame.onglets.onglet(fgeo.module)
                #if module is not None:
                #    module._ouvrir(fgeo)
                #    frame.onglets.changer_onglet(module)

        except:
            print_error() # affiche l'erreur intercepte,  titre informatif
    except:
        app.RestoreStdio()
        raise
    #~ print "test3"
    frame.Show(True)
    #~ print "test"
    app.MainLoop()
