# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

##--------------------------------------#######
#           Redefinitions mathlib             #
##--------------------------------------#######
#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2007  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# version unicode
  
# Rdfinition des fonctions mathmatiques usuelles,  partir des librairies 'math' et 'pylab'.
# Le but est d'utiliser l'un ou l'autre selon l'objet pass en argument 
# (on pourrait utiliser toujours 'pylab', mais dans les cas courants (int, float, long), 'math' est bien plus rapide).

from pylib import fonctions_matplotlib, fonctions_maths
import math as __math__
import pylib.pylab_ as __pylab__

#print globals()

# __fonctions_integrees__ = [key for key, val in __builtins__.__dict__.items() if type(val) == types.BuiltinFunctionType]

__math__.arcsin = __math__.asin
__math__.arccos = __math__.acos
__math__.arctan = __math__.atan
fonctions_maths += ["arccos", "arcsin", "arctan"]

for __nom__ in fonctions_matplotlib:
    if __nom__ in fonctions_maths:
        exec("""def %s(*args):
            if type(args[0]) in (int, float, long): return __math__.%s(*args)
            else:   return __pylab__.%s(*args)""" %(__nom__, __nom__, __nom__))
        
        exec("%s.__doc__ = __math__.%s.__doc__" %(__nom__, __nom__))


# On redefinit les fonctions mathematiques pour qu'elles supportent le maximum de types en entree.
# Exemple :

#def log(x):
#    if type(x) in (int, float,long):
#        return math.log(x)
#    else:
#        return pylab_.log(x)
        
del fonctions_matplotlib, fonctions_maths

# Alias :
ln = log
asin = arcsin
acos = arccos
atan = arctan
rc = rac = sqrt
ent = floor # partie entire (diffre de int pour les ngatifs)

from pylib.pylab_ import arcsinh, arccosh, arctanh

e = __math__.e
pi = __math__.pi
i = 1j
#from mathlib.objets import oo, infini

def deg(x):
    if isinstance(x, (list, tuple)):
        x = array(x)
    return x*180/pi

def rad(x):
    if isinstance(x, (list, tuple)):
        x = array(x)
    return x*pi/180
