# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)


##--------------------------------------#######
#                 infos pylib                 #
##--------------------------------------#######
#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2007  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# version unicode

import sys as __sys__
import wx as __wx__
import matplotlib as __matplotlib__
import os as __os__
import platform as __platform__
import locale as __locale__

class dossier(object):
    def __init__(self, titre):
        self.__titre__ = titre
    
    def contenu(self):
        l = []
        l.append("+ " + self.__titre__ + ":")
        if hasattr(self, "version"):
            l.append("     Version: " + self.version)
        for key in self.__dict__:
            if key not in ("__titre__", "version"):
                l.append("     %s:  %s" %(key.capitalize(), getattr(self, key)))
        return "\n".join(l) + "\n\n"



def informations_configuration():
    os = dossier("Systeme")
    os.repertoire = __os__.getcwd()
    os.processeur = __os__.environ.get("PROCESSOR_IDENTIFIER", "")
    os.version = __platform__.platform().replace("-", " ")
    if os.version.startswith("Windows"):
        os.version += " (%s.%s build %s (%s) - %s)" %__sys__.getwindowsversion()
#    os.version = __sys__.platform
#    try:
#        __major__, __minor__, __build__, __platform__, __text__ = __sys__.getwindowsversion()
#        if __platform__ is 0:
#            __platform__ = "win32s"
#        elif __platform__ is 1:
#            __platform__ = "Windows 9x/ME"
#        elif __platform__ is 2:
#            __platform__ = "Windows NT/2000/XP"
#        else:
#            __platform__ = "Unknown"
#        os.version += "  %s version %s.%s %s build %s" %(__platform__, __major__, __minor__, __text__, __build__)
#    except AttributeError:
#        pass
    local = dossier("Localisation")
    local.langue = __locale__.getdefaultlocale()[0]
    local.encodage = __locale__.getpreferredencoding()
    
    python = dossier("Python")
    python.encodage = __sys__.getdefaultencoding() + " / Noms de fichiers: " + __sys__.getfilesystemencoding()
    python.version = __sys__.version
    python.executable = __sys__.executable

    # Pas tres utile :
#    python.api = __sys__.api_version
#    python.recursions = __sys__.getrecursionlimit()
    
    
    
    wxpython = dossier("WxPython")
    wxpython.portage = "  ".join(__wx__.PlatformInfo[1:])
    wxpython.version = __wx__.VERSION_STRING
    
    # Le code suivant provoque un Memory Leak de WxPython :
#    __p__ = __wx__.PlatformInformation()
#    wxpython.architecture = __p__.GetArchName() + "  " + __p__.GetEndiannessName()
#    wxpython.os = "%s  %s.%s" %(__p__.GetOperatingSystemFamilyName(), __p__.GetOSMajorVersion(), __p__.GetOSMinorVersion())
    
    matplotlib = dossier("Matplolib")
    matplotlib.version = __matplotlib__.__version__
    matplotlib.tex = __matplotlib__.rcParams["text.usetex"]
    matplotlib.numerix = __matplotlib__.rcParams["numerix"] + " (" + __matplotlib__.numerix.version + ")"
    
    
    return os.contenu() + local.contenu() + python.contenu() + wxpython.contenu() + matplotlib.contenu()
